import { Component, Input, ContentChild, TemplateRef, ElementRef, Renderer } from '@angular/core';
import { AlgoliaService } from '../algolia.service';
export class AlgoliaFacetsComponent {
    constructor(as, elementRef, renderer) {
        this.as = as;
        // renderer.listen(elementRef.nativeElement, 'click', (event) => {
        //   debugger;
        // });
    }
    ngOnInit() {
        this.as.addFacet(this.attribute);
        if (this.limit) {
            this.as.parameters.maxValuesPerFacet = this.limit;
        }
    }
    isFacetActive(value) {
        return (this.as.facetFilters[this.attribute] && this.as.facetFilters[this.attribute].includes(value)) ? true : false;
    }
    ;
    updateSearch(facet) {
        if ((this.as.facetFilters[this.attribute] === undefined) || !this.as.facetFilters[this.attribute].includes(facet.key)) {
            this.as.addFacetFilter(this.attribute, facet);
        }
        else {
            this.as.removeFacetFilter(this.attribute, facet);
        }
    }
}
AlgoliaFacetsComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-algolia-facets',
                template: `
  <div>
    <p *ngIf="label"><b>{{label}}</b></p>
    <ul *ngIf='as.content.facets !== undefined' class="facets">
      <li *ngFor="let facet of as.content.facets[attribute] | mapToIterable">
        <div (click)="updateSearch(facet)" [ngClass]="isFacetActive(facet.key) ? selectedcssclass : ''" class="facet-item">
          <template [ngTemplateOutlet]="itemTemplate" [ngOutletContext]="{item: facet}"></template>
        </div>
      </li>
    </ul>
  </div>
  `,
                styles: [`
  :host {
    display: block;
    clear: both;
  }
  .facets {
    list-style: none;
    padding: 0;
    margin: 0;
    line-height: 1.42857143;
  }
  .facet-item {
    cursor: pointer;
  }
  `]
            },] },
];
/** @nocollapse */
AlgoliaFacetsComponent.ctorParameters = () => [
    { type: AlgoliaService, },
    { type: ElementRef, },
    { type: Renderer, },
];
AlgoliaFacetsComponent.propDecorators = {
    'attribute': [{ type: Input },],
    'label': [{ type: Input },],
    'limit': [{ type: Input },],
    'selectedcssclass': [{ type: Input },],
    'itemTemplate': [{ type: ContentChild, args: [TemplateRef,] },],
};
//# sourceMappingURL=/Users/olivier/lab/algolia/algolia-components/lib/algolia-facets/algolia-facets.component.js.map