import { Component, Input } from '@angular/core';
import { AlgoliaService } from '../algolia.service';
export class AlgoliaSearchComponent {
    constructor(as) {
        this.as = as;
        this.hitsPerPage = 12;
        this.placeHolder = "Search";
    }
    ngOnInit() {
        this.as.setIndex(this.index);
        this.as.parameters.hitsPerPage = this.hitsPerPage;
        this.as.search();
    }
    onKey(str) {
        this.as.query = str;
        this.as.search();
    }
}
AlgoliaSearchComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-algolia-search',
                template: `
    <div>
      <input type="text" #searchbox (keyup)="onKey(searchbox.value)" placeholder="{{placeHolder}}">
    </div>
  `,
                styles: [`
    input { 
      width: 100%;
      padding: 10px;
      font-size: 1.2em;
      box-sizing: border-box;
    }`]
            },] },
];
/** @nocollapse */
AlgoliaSearchComponent.ctorParameters = () => [
    { type: AlgoliaService, },
];
AlgoliaSearchComponent.propDecorators = {
    'index': [{ type: Input },],
    'hitsPerPage': [{ type: Input },],
    'placeHolder': [{ type: Input },],
};
//# sourceMappingURL=/Users/olivier/lab/algolia/algolia-components/lib/algolia-search/algolia-search.component.js.map