import { NgModule, Optional, SkipSelf } from '@angular/core';
import { CommonModule } from '@angular/common';
import { AlgoliaSearchComponent } from './algolia-search/algolia-search.component';
import { AlgoliaResultsComponent } from './algolia-results/algolia-results.component';
import { AlgoliaFacetsComponent } from './algolia-facets/algolia-facets.component';
import { MapToIterablePipe } from './map-to-iterable.pipe';
import { AlgoliaSortComponent } from './algolia-sort/algolia-sort.component';
import { AlgoliaPaginationComponent } from './algolia-pagination/algolia-pagination.component';
import { AlgoliaStatsComponent } from './algolia-stats/algolia-stats.component';
import { AlgoliaService, ApiServiceConfig } from './algolia.service';
import { AlgoliaStarsComponent } from './algolia-stars/algolia-stars.component';
export class AlgoliaModule {
    constructor(parentModule) {
        if (parentModule) {
            throw new Error('CoreModule is already loaded. Import it in the AppModule only');
        }
    }
    static forRoot(config) {
        return {
            ngModule: AlgoliaModule,
            providers: [
                { provide: ApiServiceConfig, useValue: config }
            ]
        };
    }
}
AlgoliaModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                ],
                exports: [AlgoliaSearchComponent, AlgoliaResultsComponent, AlgoliaFacetsComponent, AlgoliaSortComponent, AlgoliaPaginationComponent, AlgoliaStatsComponent, AlgoliaStarsComponent],
                declarations: [AlgoliaSearchComponent, AlgoliaResultsComponent, AlgoliaFacetsComponent, MapToIterablePipe, AlgoliaSortComponent, AlgoliaPaginationComponent, AlgoliaStatsComponent, AlgoliaStarsComponent],
                providers: [AlgoliaService]
            },] },
];
/** @nocollapse */
AlgoliaModule.ctorParameters = () => [
    { type: AlgoliaModule, decorators: [{ type: Optional }, { type: SkipSelf },] },
];
//# sourceMappingURL=/Users/olivier/lab/algolia/algolia-components/lib/algolia.module.js.map